<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side ref="treeSide" :dataLoading="treeLoading" :default-expand-all="false" :defaultProps="defaultProps"
                   :tabList="['组织树']" :treeData="treeData" isDeselect @currentChange="currentChange"></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <SearchCommon :optionList="optionList" @search="handleSearch" />
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button :disabled="isDisabled" class="btn btn-plus" icon="el-icon-plus" size="small"
                           type="primary" @click="changePage('EditAddPage', { catalogId: treeItem.id })">
                  添加
                </el-button>
                <el-button :disabled="!currentDataDel.length" class="btn btn-delete" icon="el-icon-delete" plain
                           size="small"
                           type="danger" @click="handleDelete()">
                  删除
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table ref="multipleSelection" v-loading="tableLoading" :data="tableData"
                          :max-height="tableMaxHeight" border class="table-list"
                          element-loading-background="rgba(10 ,38 ,61, 0.9)"
                          row-key="id"
                          stripe @select="handleSelection" @selection-change="handleSelectionChange"
                          @row-dblclick="handleDbClick">
                  <el-table-column align="center" type="selection" width="55" />
                  <el-table-column align="center" label="序号" type="index" width="60" />
                  <el-table-column align="center" label="公司全称" min-width="80" prop="name"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="公司简称" min-width="80" prop="shortName"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="公司法人" min-width="80" prop="man" show-overflow-tooltip />
                  <el-table-column align="center" label="所属组织" min-width="80" prop="orgName"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="公司营业执照编码" min-width="80" prop="code"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="公司联系电话" min-width="80" prop="tel"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="公司地址" min-width="80" prop="address" show-overflow-tooltip>
                  </el-table-column>
                  <el-table-column align="center" label="操作" min-width="80" show-overflow-tooltip>
                    <template v-slot="{ row }">
                      <el-link :underline="false" type="primary" @click="handleDetailPagea(row)">
                        二维码管理
                      </el-link>
                      <el-link :underline="false" type="primary" @click="handleDetailPage(row)">
                        详情
                      </el-link>
                      <!--                      <el-link :underline="false" type="danger" @click="handleDelete(row)">-->
                      <!--                        删除-->
                      <!--                      </el-link>-->
                    </template>
                  </el-table-column>
                </el-table>
                <pagination ref="paginationPanel" :pageResult="params.pageBean" style="margin-top: 10px"
                            @size-change="handleSizeChange" @current-change="handleCurrentChange" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <QrCodeDialog :companyId="currentCompanyId" :isShowDetail="dialogVisible"
                  @update:isShowDetail="val => dialogVisible = val"></QrCodeDialog>
  </div>
</template>

<script>
import QrCodeDialog
  from '@/views/patrolAndRescue/infoMgmtPatrolsRescues/OutsourcingCompanyMgmt/components/QrCodeDialog/index.vue'
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import treeSide from '@/components/treeSide/index.vue'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {tableData, tableDelete} from '@/api/patrolAndRescue/infoMgmtPatrolsRescues/outsourcingCompanyMgmt'
import PubSub from 'pubsub-js'
import {orgTree} from '@/api/tree'

export default {
  name: 'TablePage',
  components: {
    QrCodeDialog,
    pagination,
    treeSide,
    SearchCommon
  },
  mixins: [TableMixin],
  data() {
    return {
      currentCompanyId: null,
      dialogVisible: false,
      pubSub: null,
      tableMaxHeight: '600px',
      loading: false,
      tableLoading: false,
      treeLoading: true,
      treeData: [], //左边树
      //根据 defaultProps 配置项来解析树形结构。
      defaultProps: {
        children: 'children', //子节点
        label: 'name' //节点标签
      },
      tableData: [],
      currentDataDel: [],
      optionList: [
        {title: '公司全称', prop: ['name'], type: 'input', default: true},
        {title: '公司地址', prop: ['address'], type: 'input'},
        {title: '公司营业执照编码', prop: ['code'], type: 'input'}
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'LIKE', property: 'name', value: ''},
          {operation: 'LIKE', property: 'code', value: ''},
          {operation: 'LIKE', property: 'address', value: ''},
          {operation: 'IN', property: 'org_id_', value: ''}
        ],
        sorter: []
      },
      isDisabled: true,
      treeDialog: false, // 科目信息弹层
      treeItemId: '', // 树形目录id
      treeItem: {}, // 树形节点选中对象
      treeItemParentId: '' // 树形目录父级id
    }
  },
  created() {
    // 获取树形目录-
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id)//通过 $refs 获取treeSide组件引用，并调用 setCurrentKey方法设置当前选中的树节点。
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'org_id_', array) //将选中的树节点的 path 设置为查询参数的一部分，用于后续的表格数据请求。
      this.loadData() //加载表格数据
    })
  },
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.params.pageBean.page = 1
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })

  },
  methods: {
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    handleDetailPagea(row) {
      console.log(row, '数据')
      console.log(row.id, '当前行id')
      this.currentCompanyId = row.id
      this.dialogVisible = true
    },
    // 获取公司树-异步方法，用于从后端获取树形数据
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true   //开始加载时显示加载状态
        // let treeList = await orgTree()
        let {value} = await orgTree()  // 调用 API 获取树形数据
        this.treeData = [value]
      } finally {
        this.treeLoading = false// 无论成功或失败，都关闭加载状态
        callback && callback(this.treeData)// 如果提供了回调函数，则调用它并传入树形数据
      }
    },
    //左边树节点，点击选择
    currentChange(nodeItem) {
      if (nodeItem.id === '1766017468444450816') {
        this.isDisabled = true
        setQueryValue(this.params, 'org_id_ ', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isDisabled = true
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'org_id_ ', array)
      } else {
        this.isDisabled = false
        setQueryValue(this.params, 'org_id_ ', [nodeItem?.id] || [])
      }


      // 修改对应的字段值--重点-点击选择传id
      // setQueryValue(this.params, 'org_id_', nodeItem?.id || '') //将选中的树节点的 id 设置为查询参数的一部分。
      this.treeItem = nodeItem || {}
      console.log(this.treeItem, '/id树的id')
      this.calcTableHeight(500)
      // 触发 TreeItemSelected 事件，并传递节点数据
      PubSub.publish('TreeItemSelected', nodeItem)
      this.params.pageBean.page = 1
      this.loadData()
    },
    //获取数据
    async loadData() {
      this.tableLoading = true
      console.log('查询参数:', this.params) // 打印查询参数
      const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
      this.params.pageBean.total = total
      this.tableData = rows
      this.tableLoading = false
    },


    // 删除
    handleDelete(row) {
      this.clickTimer = true
      this.$confirm('确定删除选中外包公司信息吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        let ids = row ? row.id : this.currentDataDel.join()
        let {state, message} = await tableDelete(ids)
        if (state) {
          this.$message.success(`外包公司信息删除成功`)
          const {page, pageSize, total} = this.params.pageBean
          const totalPages = Math.ceil(total / pageSize) // 计算总页数
          if (totalPages > 1 && page === totalPages) {
            if (this.tableData.length === 1) { // 当前页只有一条数据
              this.params.pageBean.page -= 1 // 返回前一页
            }
          }
          await this.loadData()
        } else {
          this.$message.error(message)
        }
      }).catch(_ => _)
    },

    //双击修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      this.changePage('EditAddPage', row)
    },

    // 改变页面
    changePage(pageName = '', row = {}) {
      if (!pageName) return
      // 传递当前选中的树节点信息
      const payload = row.id ? row : {
        catalogId: this.treeItem.id,
        orgName: this.treeItem.name,
        path: this.treeItem.path,
        clearForm: true // 清空表单标志
      }
      this.$emit('changePage', pageName, _ => {
        PubSub.publish(pageName, payload)
      }, row.id ? '编辑' : '添加')
    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped></style>
